unit slide_1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, math, types, BGRABitmap, BGRABitmapTypes;

type

  { TForm1 }

  TForm1 = class(TForm)
    knop: TButton;
    procedure FormWindowStateChange(Sender: TObject);
    procedure knopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    image: TBGRABitmap;
    image_from : TBGRABitmap;
    image_to   : TBGRABitmap;

  public

  end;

var
  Form1: TForm1;
  nfoto : integer;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.knopClick(Sender: TObject);
var
  nknop : integer;
  str_foto_from, str_foto_to : string;
begin
  if nfoto = 0 then
  begin
    str_foto_from := 'img_044000d.jpg';
    str_foto_to   := 'img_045014d.jpg';
  end;
  if nfoto = 1 then
  begin
    str_foto_from := 'img_045014d.jpg';
    str_foto_to   := 'img_044333d.jpg';
  end;
  if nfoto = 2 then
  begin
    str_foto_from := 'img_044333d.jpg';
    str_foto_to   := 'img_042000d.jpg';
  end;
  image_from.LoadFromFile( str_foto_from);
// change image-size to a fullsized form
  BGRAReplace(image_from, image_from.Resample(Form1.Width, Form1.Height, rmSimpleStretch));

  image_to.LoadFromFile( str_foto_to );
  // change image-size to a fullsized form
  BGRAReplace(image_to, image_to.Resample(Form1.Width, Form1.Height, rmSimpleStretch));

  nfoto := nfoto + 1;
  if nfoto = 3 then nfoto := 0;

// fading using crossqfade by incresing transparency-value (from 1 to 255 by step of 5
  for nknop := 1 to 51 do
  begin
    knop.Tag := nknop;
    form1.Tag := 1;
// call form-paint-event
    form1.Repaint;
  end;
end;

procedure TForm1.FormWindowStateChange(Sender: TObject);
begin
  image.SetSize(ClientWidth,ClientHeight);
  image.Fill(BGRABlack);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  image_from := TBGRABitmap.Create;
  image_to   := TBGRABitmap.Create;
  image      := TBGRABitmap.Create;
  image.SetSize(ClientWidth,ClientHeight);
  image.Fill(BGRABlack);
  nfoto := 0;
end;

procedure TForm1.FormPaint(Sender: TObject);
var r
  destRect: TRect;
begin
  if form1.Tag = 1 then
  begin
// create an image from two images with transparency  FormPaint is put in a loop while increasing the transparancy of image 2(image_to), decreasing image 1 (image_from)
    image.CrossFade(Rect(0,0,image.Width, image.Height), image_from, image_to, round(knop.tag * 5), dmSet);
      sleep( 20 );
      image.   Draw(Canvas, 0,0);
    Form1.Tag := 2; // ready to next
  end;
end;

end.

